#property copyright "Denis Domchik"

extern int trailingStop=25;
extern int stopLoss=45;
extern int takeProfit=100;
extern double lots=0.1;
extern int slippage = 3;
extern int ema3_period=3;
extern int ema5_period=5;
extern int ema13_period=13;
extern int ema21_period=21;
extern int ema80_period=80;
extern double raviMax = 0.1;
extern double raviMin = -0.1;
extern string ExpertName = "MultiEma_1";
extern int ExpertID = 8544563;
extern bool UseMM = false;
extern double Risk = 10;
extern int minCrossDistance = 1;
extern int maxCrossDistance = 7;



int init()
  {
   
   GlobalVariableSet("allowLong",1); 
   GlobalVariableSet("allowShort",1); 
   Comment(ExpertName + " is waiting for the next tick to begin.");	
   return(0);
  }

int deinit()
  {
  
	
   return(0);
  }

int start()
  {
    
     int total=OrdersTotal(),
         i,
         cnt;
      
      
   if (UseMM)
   {
      lots = CalculateLotSize();
   } 
   
   Print("lots = " + lots);
        
   bool longOk=false;   
   bool shortOk=false;
   bool orderIsOpen = isOrderOpened();   
   
   double ema3 = iMA(NULL,0,ema3_period,0,MODE_EMA,PRICE_CLOSE,0);
   double ema5 = iMA(NULL,0,ema5_period,0,MODE_EMA,PRICE_CLOSE,0);
   double ema13 = iMA(NULL,0,ema13_period,0,MODE_EMA,PRICE_CLOSE,0);
   double ema21 = iMA(NULL,0,ema21_period,0,MODE_EMA,PRICE_CLOSE,0);
   double ema80 = iMA(NULL,0,ema80_period,0,MODE_EMA,PRICE_CLOSE,0);
   double rsi = iRSI(NULL, 0, 21, PRICE_CLOSE, 0);
    

   

 
  
    
   if(ema3 > ema5 && ema5 > ema13 && ema13 > ema21 && ema21 > ema80 && rsi >= 50 )
   {
     longOk = true;
     shortOk = false;
     
   }
    
  
    if(ema80 > ema21 && ema21 > ema13 && ema13 > ema5 && ema5 > ema3 && rsi <= 50 ) 
    {
      shortOk = true;
      longOk = false;
     
 
    }
  
   int Distance      = MathFloor(MathAbs((ema3-ema5)/Point));
   int Distance2     = MathFloor(MathAbs((ema13-ema21)/Point)); //maxCrossDistance
   
    Print("shortok =" +shortOk);
    Print("longok =" +longOk);
    Print("distance = " + Distance);
   
    static int isCrossed  = 0;
    static int isCrossedBig = 0;
    isCrossed = Crossed(ema3,ema5);
    isCrossedBig = Crossed(ema13,ema21); 
   
    Print("isCrossed= " + isCrossed);
    if (orderIsOpen)
    { 
        Comment("Open order exists. Trailing...");
        trailOrders();
         
    }
    else
    {
       
       if (isCrossed == 1 && Distance >= minCrossDistance) //(isCrossedBig == 1) 
       {
          GlobalVariableSet("allowShort",1); 
         
       } 
      
      if (isCrossed == 2 && Distance >= minCrossDistance) //(isCrossedBig == 2) 
      {
          GlobalVariableSet("allowLong",1); 
          
      }  
      
       Comment("Myema : allowShort = " +  GlobalVariableGet("allowLong") + " " + "Distance = " + Distance + " mincrossDistance = " + minCrossDistance + " isCrossed = " + isCrossed + " shortok = " +shortOk + " longOk = " + longOk);  
       Print("Distance2= "+ Distance2);
       Print("maxCrossDistance= "+ Distance2);
      
      if  (longOk && isCrossed == 1 && Distance >= minCrossDistance && GlobalVariableGet("allowLong") == 1 )
      {
        
         Print("going long");
         int ticketBuy = OrderSendSafe(Symbol(), OP_BUY, lots, Ask, slippage, Ask-stopLoss*Point,Ask+takeProfit*Point ,ExpertName, ExpertID, 0, Lime);
        if (ticketBuy > 0)
        {
            
            GlobalVariableSet("allowLong",0); 
            //allowLong = false;
        }
      }
      
      
      if (shortOk && isCrossed ==2 && Distance >= minCrossDistance &&  GlobalVariableGet("allowShort") == 1)
      {
          Print("going short");
          int ticketSell = OrderSendSafe(Symbol(), OP_SELL, lots, Bid, slippage, Bid+stopLoss*Point,Bid - takeProfit*Point ,ExpertName, ExpertID, 0, Red);
         
          if (ticketSell > 0)
          {
         
           
            GlobalVariableSet("allowShort",0);
           
          }
      }
          
    }  
 
  }


bool isOrderOpened()
{
    int cnt;
   bool orderIsOpen = false;
   int total = OrdersTotal();  // Currently open or pending orders
 
  for(cnt = 0; cnt < total; cnt++)
  {
    OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
    if( (OrderSymbol() == Symbol()) && (OrderMagicNumber() == ExpertID) )
    {
      orderIsOpen = true;
      break;
    }
    else
      continue; 
  }  
  
  return (orderIsOpen);
}

int Crossed (double short , double long)
  {
    static int last_direction = 0;
    static int current_direction = 0;
    //Don't work in the first load, wait for the first cross!
    static bool first_time = true;
    if(first_time == true)
      {
        first_time = false;
        return (0);
      }

    if(short > long)
        current_direction = 1;  //up
    if(short < long)
        current_direction = 2;  //down

    /*  
    if(current_direction != last_direction)  //changed 
      {
        last_direction = current_direction;
        return(last_direction);
      }
    else
      {
        return (0);  //not changed
      }
   */
   
    return (current_direction);
   }
  
  
  void trailOrders()
  {
      int cnt;
      int total = OrdersTotal();
        for(cnt = 0; cnt < total; cnt++)
      {
        OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
        if(OrderType() <= OP_SELL && OrderSymbol() == Symbol() && OrderMagicNumber() == ExpertID )
          {
            if(OrderType() == OP_BUY)   // long position is opened
              {
                // check for trailing stop
                if(trailingStop > 0)  
                  {                 
                    if(Bid - OrderOpenPrice() > Point*trailingStop)
                      {
                        if(OrderStopLoss() < Bid - Point*trailingStop)
                          {       
                            OrderModifySafe(OrderTicket(), OrderOpenPrice(), Bid - Point*trailingStop, OrderTakeProfit(), 0, Green);                            
                            return(0);
                          }
                      }
                  }
              }
            else // go to short position
              {
                // check for trailing stop
                if(trailingStop > 0)  
                  {                 
                    if((OrderOpenPrice() - Ask) > (Point*trailingStop))
                      {
                        if((OrderStopLoss() > (Ask + Point*trailingStop)) || 
                           (OrderStopLoss() == 0))
                          {        
                            OrderModifySafe(OrderTicket(), OrderOpenPrice(), Ask + Point*trailingStop, OrderTakeProfit(), 0, Green);
                            return(0);
                          }
                      }
                  }
              }
          }
      }
      
   
  }
  
  int OrderSendSafe(string symbol, int cmd, double volume, double price, int slippage, double stoploss, double takeprofit, string comment, int magic=0, datetime expiration=0, color arrow_color=CLR_NONE)
 {
	int ticket;
	bool cont = true;
	
	int sleepMin = 2;
	int sleepMax = 10;
	MathSrand(TimeLocal());
	int errCode; 
	while(cont)
	{
		ticket = OrderSend(symbol, cmd, volume, price, slippage, stoploss, takeprofit, comment, magic, expiration, arrow_color);
		
		if(ticket < 0)
   		{
   		errCode = HandleLastError();
			if(errCode ==6)
			{
			   bool connect = false;
            int iteration = 0;
          
           while((!connect) || (iteration > 60))
             {
               Sleep(10000);        
               connect = IsConnected();
               if(connect)
                 {  
                   return(2);
                 }
               iteration++;
             }	
			}
			else if (errCode==129 || errCode==130 || errCode==135 || errCode==138)
			{
			   RefreshRates();
				
				int randomSeconds = MathRand() % (sleepMax - sleepMin) + sleepMin;
				Sleep(randomSeconds * 1000);
			}
			else
				cont = false;
		}
		else
			cont = false;
	}
	
	
	return (ticket);
}

void OrderModifySafe(int ticket, double price, double stoploss, double takeprofit, datetime expiration, color arrow_color=Yellow)
{
	bool cont = true;
	
	int sleepMin = 2;
	int sleepMax = 10;
	MathSrand(TimeLocal());
	int errCode; 
	while(cont)
	{	
		bool result = OrderModify(ticket, price, stoploss, takeprofit, expiration, arrow_color);
	
		if(!result)
		{
			errCode = HandleLastError();
			if(errCode == 6) //== ERR_TRADE_CONTEXT_BUSY
			{
			  bool connect = false;
           int iteration = 0;
          
           while((!connect) || (iteration > 60))
             {
               Sleep(10000);
        
                
               connect = IsConnected();
               if(connect)
                 {  
                   return;
                 }
               iteration++;
             }
			}
			else if (errCode==129 || errCode==130 || errCode==135 || errCode==138)
			{
				
				RefreshRates();
				int randomSeconds = MathRand() % (sleepMax - sleepMin) + sleepMin;
				Sleep(randomSeconds * 1000);
			}
			else
				cont = false;
		}
		else
			cont = false;
	}
}

int HandleLastError(bool printInfo = true)
{
	int error = GetLastError();
	
	if(error > 0 && printInfo)
	{
	
	   Print("Error #", error, ": ", error); //ErrorDescription(error)  
	}
	
	return (error);
}


double CalculateLotSize()
{

	//double pipValue = MarketInfo(Symbol(), MODE_TICKVALUE);
	//double lots = AccountFreeMargin() * Risk / (stopLoss * pipValue);
	double lots = MathCeil(AccountFreeMargin() *  Risk / 1000) / 100;
	
	double lotStep = MarketInfo(Symbol(), MODE_LOTSTEP);
	int digits = 0;
	if(lotStep <= 0.01)
		digits = 2;
	else if(lotStep <= 0.1)
		digits = 1;
	lots = NormalizeDouble(lots, digits);
  	
  	double minLots = MarketInfo(Symbol(), MODE_MINLOT);
  	if(lots < minLots)
  		lots = minLots;
  	
  	double maxLots = MarketInfo(Symbol(), MODE_MAXLOT);
  	if(lots > maxLots)
  		lots = maxLots;
  	
  	return (lots);
}